#include "./OversamplingControlGui.h"

using namespace gmpi;
using namespace gmpi_gui;

GMPI_REGISTER_GUI(MP_SUB_TYPE_GUI2, OversamplingControlGui, L"SE Oversampling Control");

OversamplingControlGui::OversamplingControlGui()
{
	// initialise pins.
	initializePin(pinHostOversampling,&OversamplingControlGui::onSetHostOversampling );
	initializePin(pinHostListItems,&OversamplingControlGui::onSetHostLists );
	initializePin(pinHostOversamplingFilter );
	initializePin(pinHostListItems2, &OversamplingControlGui::onSetHostLists );
	initializePin(pinOversampling,&OversamplingControlGui::onSetOversampling );
	initializePin(pinListItems);
	initializePin(pinOversamplingFilter);
	initializePin(pinListItems2);

    init=0;

}

// handle pin updates.
void OversamplingControlGui::onSetHostOversampling()
{
 //if(init>=1)pinOversampling=pinHostOversampling;
 if(init==0)pinOversampling=pinHostOversampling;
 //if(init>=2 && pinHostOversampling != pinOversampling )pinHostOversampling = pinOversampling;
 if(init>=1 )pinHostOversampling = pinOversampling;
  init++; // increment the count each time this pin is triggered or initialized!
}

void OversamplingControlGui::onSetHostLists()
{
	pinListItems = pinHostListItems;
	pinListItems2 = pinHostListItems2;
}

void OversamplingControlGui::onSetHoatOversamplingFilter()
{
	pinOversamplingFilter = pinHostOversamplingFilter;
}

void OversamplingControlGui::onSetOversampling()
{

    if(init>=1 && 	pinHostOversampling != pinOversampling )
    {

    wchar_t title[100];
    wchar_t msg[350];
    int sr_current = pinHostOversampling;

    if(sr_current!=0)swprintf(title, 100, L"SR = %i x 44k-48k", sr_current );
    else
    swprintf(title, 100, L"SR = DAW");

    swprintf(msg, 350, L"Update SR?\nTHE PLUG-IN WILL BE RESETED -> RISK OF CPU SPIKE!\nPlease STOP your session!\nIF YOU LOAD PRESETS WITH A DIFFERENT SR VALUE WITH YOUR DAW\nTHE PLUG-IN WILL BE RESETED!\nFor a good use it is recommended to indicate the SR value in the filename and to use the plug-in preset manager to avoid this issue (to do list).");

    int msgboxID = MessageBox(NULL, msg, title, MB_ICONWARNING | MB_YESNO);

    switch (msgboxID)
    {
        case IDYES:
           	pinHostOversampling = pinOversampling;
        break;
        case IDNO:
            pinOversampling = pinHostOversampling;
        break;
    }


  }
  init++; // increment the count each time this pin is triggered or initialized!
}

void OversamplingControlGui::onSetOversamplingFilter()
{
	pinHostOversamplingFilter = pinOversamplingFilter;
}

